#ifndef AFX_ARCDLL_H__911C109D_A40E_4722_A6F7_E3ACB8C2D2E3__INCLUDED_
#define AFX_ARCDLL_H__911C109D_A40E_4722_A6F7_E3ACB8C2D2E3__INCLUDED_

#include "Archiver.h"

class CArcDLL : public CArchiver
{
public:
	CArcDLL(
		const char*  Dllname,	// DLL
		const char*  Exts,		// Ήgq
		const char*  Ecmd,		// 𓀗pR}h
		const char*  Xcmd,		// 𓀗pR}h
		unsigned int Wild=1,	// ChJ[ȟ`( 0=no(*) 1=* 2=*.* )
		const char*  Scmd=NULL )// SFXϊpR}h
		: dll( Dllname ), CArchiver( Exts ), m_Ecmd( Ecmd ),
			m_Xcmd( Xcmd ), m_Wild( Wild ), m_Scmd( Scmd ) {}

protected: //-- hĂ悵
	virtual DWORD set_cmpr_mhd()
		{ return 0; }
	virtual const char* get_cmpr_ext( int method )
		{ return cmp_ext(); }
	virtual const char* get_cmpr_cmd( int method )
		{ return ""; }
	virtual void decorate_add_cmpr( kiStr& lst, const char* fname );
	virtual void decorate_add_melt( kiStr& lst, const char* fname );

protected: //-- 
	CArcModule dll;
	bool v_ver( kiStr& str ){ dll.ver(str); return true; }
	bool v_check( const kiPath& aname ){ return dll.chk(aname); }
	int  v_contents( const kiPath& aname, kiPath& dname ){ return dll.cnt(aname,dname,m_Wild==2?"*.*":"*"); }
	bool v_list( const arcname& aname, aflArray& files ){ return dll.lst_dll(aname,files,m_Wild==2?"*.*":"*"); }

	int  v_load();
	int  v_melt( const arcname& aname, const kiPath& ddir, const aflArray* files );
	int  v_compress( const kiPath& base, const wfdArray& files, const kiPath& ddir, int method, bool sfx );

private:
	const char *m_Ecmd, *m_Xcmd, *m_Scmd;
	unsigned int m_Wild;
	int  cmpr( int mhd, kiStr& aname,const kiPath& to,const kiStr& lst );
	bool arc2sfx( const kiStr& aname );
};

//------------------------------------------------------------//

class CArcDLL_DotSlash : public CArcDLL
{
	// "./-"  "./@" Ƃ邱ƂłƂ肠k`
	virtual void decorate_add_cmpr( kiStr& lst, const char* fname );

protected:
	CArcDLL_DotSlash(
		const char*  Dllname,
		const char*  Exts,
		const char*  Ecmd,
		const char*  Xcmd,
		unsigned int Wild=1,
		const char*  Scmd=NULL )
		: CArcDLL( Dllname, Exts, Ecmd, Xcmd, Wild, Scmd ) {}
};

//------------------------------------------------------------//

class CArcRar : public CArcDLL
{
public:
	CArcRar() : CArcDLL(
		"Unrar32.dll",
		"rar.",
		"-x",
		"-x -s -y --" ) {}
private:
	// ʂɔh
	bool v_check( const kiPath& aname );
	int  v_melt( const arcname& aname, const kiPath& ddir, const aflArray* files );
};

//------------------------------------------------------------//

class CArcUnZip : public CArcDLL
{
public:
	CArcUnZip() : CArcDLL(
		"UnZip32.dll",
		"zip.jar.",
		"-x",
		"-x --i -o" ) {}
private:
	// ʂɔh
	int  v_melt( const arcname& aname, const kiPath& ddir, const aflArray* files );
};

//------------------------------------------------------------//

class CArcLzh : public CArcDLL
{
public:
	CArcLzh() : CArcDLL(
		"Unlha32.dll",
		"lzh.lha.lzs.",
		"x -a1 -jf0",
		"x -a1 -jf0 -jyo -p1 -n -gm --",
		0,
		"s -gw3 -x1" ) {}
private:
	DWORD set_cmpr_mhd();
	const char* get_cmpr_cmd( int method );
	void decorate_add_cmpr( kiStr& lst, const char* fname );
	void decorate_add_melt( kiStr& lst, const char* fname );
};

//------------------------------------------------------------//

class CArcZip : public CArcDLL
{
public:
	CArcZip() : CArcDLL(
		"Zip32j.dll",
		"",
		NULL,
		NULL,
		1,
		"--sfx" ) {}
private:
	DWORD set_cmpr_mhd();
	const char* get_cmpr_cmd( int method );
	void decorate_add_cmpr( kiStr& lst, const char* fname );
};

//------------------------------------------------------------//

class CArcCab : public CArcDLL_DotSlash
{
public:
	CArcCab() : CArcDLL_DotSlash(
		"Cab32.dll",
		"cab.",
		"-x",
		"-x -i -o",
		1,
		"-f" ) {}
private:
	DWORD set_cmpr_mhd();
	const char* get_cmpr_cmd( int method );
};

//------------------------------------------------------------//

class CArcTar : public CArcDLL_DotSlash
{
public:
	CArcTar() : CArcDLL_DotSlash(
		"Tar32.dll",
		"tar.tgz.tbz.gz.bz2.z.taz.rpm.deb.ar.",
		"-xvf",
		"--check-all-path=1 --display-dialog=0 -xvf",
		2 ) {}
private:
	const char* get_cmpr_ext( int method );
	DWORD set_cmpr_mhd();
	const char* get_cmpr_cmd( int method );
};

//------------------------------------------------------------//

class CArcBga : public CArcDLL_DotSlash
{
public:
	CArcBga() : CArcDLL_DotSlash(
		"Bga32.dll",
		"gza.bza.",
		"x -a",
		"x -a -i -o",
		0,
		"s" ) {}
private:
	const char* get_cmpr_ext( int method );
	DWORD set_cmpr_mhd();
	const char* get_cmpr_cmd( int method );
};

//------------------------------------------------------------//

class CArcYz1 : public CArcDLL
{
public:
	CArcYz1() : CArcDLL(
		"Yz1.dll",
		"yz1.",
		"x",
		"x -y -z -i2 --",
		0,
		"s" ) {}
private:
	DWORD set_cmpr_mhd();
	const char* get_cmpr_cmd( int method );
};

//------------------------------------------------------------//

#define CArcArj CArcDLL( "Unarj32j.dll", "arj.", "x -jyc", "x -y -p -hm -i -!" )

//------------------------------------------------------------//

#define CArcGca CArcDLL( "UnGCA32.dll", "gca.", "e -sx1", "ex -xx1 -sx0 -yx0" )

//------------------------------------------------------------//

class CArc7z : public CArcDLL_DotSlash
{
public:
	CArc7z() : CArcDLL_DotSlash(
		"7-zip32.dll",
		"7z.",
		"x",
		"x -y -hide",
		1,
		"" ) {}
private:
	DWORD set_cmpr_mhd();
	const char* get_cmpr_cmd( int method );
	const char* get_cmpr_ext( int method );
	virtual int v_compress( const kiPath& base, const wfdArray& files, const kiPath& ddir, int method, bool sfx );
	bool m_SfxMode;
};

//------------------------------------------------------------//

class CArc7zZip : public CArcDLL_DotSlash
{
public:
	CArc7zZip() : CArcDLL_DotSlash(
		"7-zip32.dll",
		"",NULL,NULL,1,"" ) {}
private:
	DWORD set_cmpr_mhd();
	const char* get_cmpr_cmd( int method );
	virtual bool v_ver( kiStr& ){return false;}//CArc7zɔC
	virtual int v_compress( const kiPath& base, const wfdArray& files, const kiPath& ddir, int method, bool sfx );
};

//------------------------------------------------------------//

#endif
